blob: 6e1187ed091e54c90cf274f5ca92c8141d240345 [file] [log] [blame]
Denis Vlasenko7d219aa2006-10-05 10:17:08 +00001#!/bin/sh
2
3debug=false
4
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +00005# Linker flags used:
6#
7# Informational:
8# --warn-common
9# -Map $EXE.map
10# --verbose
11#
12# Optimizations:
13# --sort-common reduces padding
14# --sort-section alignment reduces padding
15# --gc-sections throws out unused sections,
16# does not work for shared libs
Denis Vlasenko42e41822007-10-09 18:01:13 +000017# -On Not used, maybe useful?
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +000018#
19# List of files to link:
20# $l_list == --start-group -llib1 -llib2 --end-group
21# --start-group $O_FILES $A_FILES --end-group
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +000022#
23# Shared library link:
24# -shared self-explanatory
25# -fPIC position-independent code
Denis Vlasenko724d1962007-10-10 14:41:07 +000026# --enable-new-dtags ?
27# -z,combreloc ?
28# -soname="libbusybox.so.$BB_VER"
Denis Vlasenko9b49a5e2007-10-11 10:05:36 +000029# --undefined=lbb_main Seed name to start pulling from
Denis Vlasenko724d1962007-10-10 14:41:07 +000030# (otherwise we'll need --whole-archive)
31# -static Not used, but may be useful! manpage:
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +000032# "... This option can be used with -shared.
33# Doing so means that a shared library
34# is being created but that all of the library's
35# external references must be resolved by pulling
36# in entries from static libraries."
37
38
Denis Vlasenko018e0852007-02-25 00:40:37 +000039try() {
Denis Vlasenko32404742007-10-07 17:05:22 +000040 printf "%s\n" "Output of:" >$EXE.out
41 printf "%s\n" "$*" >>$EXE.out
42 printf "%s\n" "==========" >>$EXE.out
43 $debug && echo "Trying: $*"
Bernhard Reutner-Fischer2dfd2952008-10-23 13:49:21 +000044 $@ >>$EXE.out 2>&1
45 return $?
Denis Vlasenko7d219aa2006-10-05 10:17:08 +000046}
47
Denis Vlasenko130f5592007-11-13 17:36:12 +000048check_cc() {
Mike Frysinger4a08e822015-03-16 17:46:17 -040049 local tempname="$(mktemp)"
Denys Vlasenko51340102015-10-20 16:16:16 +020050 local r
51 echo "int main(int argc,char**argv){return argv?argc:0;}" >"$tempname".c
Denis Vlasenko0a4624a2008-02-13 07:47:37 +000052 # Can use "-o /dev/null", but older gcc tend to *unlink it* on failure! :(
Denys Vlasenko51340102015-10-20 16:16:16 +020053 # Was using "-xc /dev/null", but we need a valid C program.
Denys Vlasenkoedcd5dc2015-10-20 18:15:01 +020054 # "eval" may be needed if CFLAGS can contain
Denys Vlasenko51340102015-10-20 16:16:16 +020055 # '... -D"BB_VER=KBUILD_STR(1.N.M)" ...'
56 # and we need shell to process quotes!
Denys Vlasenko58d0e202015-10-20 16:40:43 +020057 $CC $CFLAGS $1 "$tempname".c -o "$tempname" >/dev/null 2>&1
Denys Vlasenko51340102015-10-20 16:16:16 +020058 r=$?
59 rm -f "$tempname" "$tempname".c "$tempname".o
60 return $r
Denis Vlasenko130f5592007-11-13 17:36:12 +000061}
62
Denis Vlasenko3f9c8482007-12-28 17:04:42 +000063check_libc_is_glibc() {
Mike Frysinger4a08e822015-03-16 17:46:17 -040064 local tempname="$(mktemp)"
Denys Vlasenko51340102015-10-20 16:16:16 +020065 local r
Denis Vlasenko3f9c8482007-12-28 17:04:42 +000066 echo "\
67 #include <stdlib.h>
68 /* Apparently uclibc defines __GLIBC__ (compat trick?). Oh well. */
69 #if defined(__GLIBC__) && !defined(__UCLIBC__)
70 syntax error here
71 #endif
Denis Vlasenkoa2dcb502008-04-30 00:15:56 +000072 " >"$tempname".c
Denys Vlasenko58d0e202015-10-20 16:40:43 +020073 ! $CC $CFLAGS "$tempname".c -c -o "$tempname".o >/dev/null 2>&1
Denys Vlasenko51340102015-10-20 16:16:16 +020074 r=$?
75 rm -f "$tempname" "$tempname".c "$tempname".o
76 return $r
Denis Vlasenko3f9c8482007-12-28 17:04:42 +000077}
78
Denis Vlasenko32404742007-10-07 17:05:22 +000079EXE="$1"
80CC="$2"
Denis Vlasenkof1d93ec2008-02-14 12:24:14 +000081CFLAGS="$3"
82LDFLAGS="$4"
83O_FILES="$5"
84A_FILES="$6"
85LDLIBS="$7"
Denis Vlasenko32404742007-10-07 17:05:22 +000086
Denis Vlasenkoa2dcb502008-04-30 00:15:56 +000087# The --sort-section option is not supported by older versions of ld
Denys Vlasenko51340102015-10-20 16:16:16 +020088SORT_SECTION="-Wl,--sort-section,alignment"
89if ! check_cc "-Wl,--sort-section,alignment"; then
90 echo "Your linker does not support --sort-section,alignment"
91 SORT_SECTION=""
92fi
Denis Vlasenko130f5592007-11-13 17:36:12 +000093
Dan Fandrichebeac162010-06-18 22:36:10 -070094START_GROUP="-Wl,--start-group"
95END_GROUP="-Wl,--end-group"
Dan Fandrichebeac162010-06-18 22:36:10 -070096INFO_OPTS="-Wl,--warn-common -Wl,-Map,$EXE.map -Wl,--verbose"
97
Bernhard Reutner-Fischera88585a2010-05-21 12:11:34 +020098# gold may not support --sort-common (yet)
Denys Vlasenko51340102015-10-20 16:16:16 +020099SORT_COMMON="-Wl,--sort-common"
100if ! check_cc "-Wl,--sort-common"; then
101 echo "Your linker does not support --sort-common"
102 SORT_COMMON=""
103fi
Bernhard Reutner-Fischera88585a2010-05-21 12:11:34 +0200104
Denis Vlasenko3f9c8482007-12-28 17:04:42 +0000105# Static linking against glibc produces buggy executables
106# (glibc does not cope well with ld --gc-sections).
107# See sources.redhat.com/bugzilla/show_bug.cgi?id=3400
108# Note that glibc is unsuitable for static linking anyway.
109# We are removing -Wl,--gc-sections from link command line.
Denys Vlasenko51340102015-10-20 16:16:16 +0200110GC_SECTIONS="-Wl,--gc-sections"
111if (. ./.config && test x"$CONFIG_STATIC" = x"y") then
112 if check_libc_is_glibc; then
113 echo "Static linking against glibc, can't use --gc-sections"
114 GC_SECTIONS=""
115 fi
Denis Vlasenko3f9c8482007-12-28 17:04:42 +0000116fi
Denys Vlasenkoeb1cda22009-06-27 00:24:35 +0200117# The --gc-sections option is not supported by older versions of ld
118if test -n "$GC_SECTIONS"; then
Denys Vlasenko51340102015-10-20 16:16:16 +0200119 if ! check_cc "$GC_SECTIONS"; then
120 echo "Your linker does not support $GC_SECTIONS"
121 GC_SECTIONS=""
122 fi
Denys Vlasenkoeb1cda22009-06-27 00:24:35 +0200123fi
124
Denis Vlasenko150d2fa2007-07-17 20:39:27 +0000125# Sanitize lib list (dups, extra spaces etc)
Denis Vlasenko76a6b232007-10-07 17:05:42 +0000126LDLIBS=`echo "$LDLIBS" | xargs -n1 | sort | uniq | xargs`
Denis Vlasenko150d2fa2007-07-17 20:39:27 +0000127
128# First link with all libs. If it fails, bail out
Denis Vlasenko76a6b232007-10-07 17:05:42 +0000129echo "Trying libraries: $LDLIBS"
Denis Vlasenko32404742007-10-07 17:05:22 +0000130# "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
Mike Frysinger3eab2b72013-09-12 00:29:40 -0400131l_list=`echo " $LDLIBS " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
Dan Fandrichebeac162010-06-18 22:36:10 -0700132test "x$l_list" != "x" && l_list="$START_GROUP $l_list $END_GROUP"
Denis Vlasenkof1d93ec2008-02-14 12:24:14 +0000133try $CC $CFLAGS $LDFLAGS \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000134 -o $EXE \
Bernhard Reutner-Fischera88585a2010-05-21 12:11:34 +0200135 $SORT_COMMON \
Denis Vlasenko130f5592007-11-13 17:36:12 +0000136 $SORT_SECTION \
Denis Vlasenkoa2dcb502008-04-30 00:15:56 +0000137 $GC_SECTIONS \
Dan Fandrichebeac162010-06-18 22:36:10 -0700138 $START_GROUP $O_FILES $A_FILES $END_GROUP \
Denis Vlasenko32404742007-10-07 17:05:22 +0000139 $l_list \
Denis Vlasenko150d2fa2007-07-17 20:39:27 +0000140|| {
Denis Vlasenko4824cca2008-03-21 18:29:01 +0000141 echo "Failed: $l_list"
Denis Vlasenko32404742007-10-07 17:05:22 +0000142 cat $EXE.out
Denis Vlasenko150d2fa2007-07-17 20:39:27 +0000143 exit 1
144}
Denis Vlasenko6ca409e2007-08-12 20:58:27 +0000145
Denis Vlasenko8274e062007-08-06 03:41:08 +0000146# Now try to remove each lib and build without it.
Denis Vlasenko150d2fa2007-07-17 20:39:27 +0000147# Stop when no lib can be removed.
Denis Vlasenko76a6b232007-10-07 17:05:42 +0000148while test "$LDLIBS"; do
149 $debug && echo "Trying libraries: $LDLIBS"
Denis Vlasenko150d2fa2007-07-17 20:39:27 +0000150 all_needed=true
Denis Vlasenkodd316dd2008-06-14 15:50:55 +0000151 last_needed=false
Denis Vlasenko76a6b232007-10-07 17:05:42 +0000152 for one in $LDLIBS; do
153 without_one=`echo " $LDLIBS " | sed "s/ $one / /g" | xargs`
Denis Vlasenko32404742007-10-07 17:05:22 +0000154 # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
Mike Frysinger3eab2b72013-09-12 00:29:40 -0400155 l_list=`echo " $without_one " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
Dan Fandrichebeac162010-06-18 22:36:10 -0700156 test x"$l_list" != x"" && l_list="$START_GROUP $l_list $END_GROUP"
Bernhard Reutner-Fischer8d91c132007-09-02 14:51:54 +0000157 $debug && echo "Trying -l options: '$l_list'"
Denis Vlasenkof1d93ec2008-02-14 12:24:14 +0000158 try $CC $CFLAGS $LDFLAGS \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000159 -o $EXE \
Bernhard Reutner-Fischera88585a2010-05-21 12:11:34 +0200160 $SORT_COMMON \
Denis Vlasenko130f5592007-11-13 17:36:12 +0000161 $SORT_SECTION \
Denis Vlasenkoa2dcb502008-04-30 00:15:56 +0000162 $GC_SECTIONS \
Dan Fandrichebeac162010-06-18 22:36:10 -0700163 $START_GROUP $O_FILES $A_FILES $END_GROUP \
Denis Vlasenkod19b87e2007-10-09 13:08:02 +0000164 $l_list
Denis Vlasenko32404742007-10-07 17:05:22 +0000165 if test $? = 0; then
Denis Vlasenkob522d692008-08-26 20:09:08 +0000166 echo " Library $one is not needed, excluding it"
Denis Vlasenko76a6b232007-10-07 17:05:42 +0000167 LDLIBS="$without_one"
Denis Vlasenko32404742007-10-07 17:05:22 +0000168 all_needed=false
Denis Vlasenkodd316dd2008-06-14 15:50:55 +0000169 last_needed=false
Denis Vlasenko150d2fa2007-07-17 20:39:27 +0000170 else
Denis Vlasenkob522d692008-08-26 20:09:08 +0000171 echo " Library $one is needed, can't exclude it (yet)"
Denis Vlasenkodd316dd2008-06-14 15:50:55 +0000172 last_needed=true
Denis Vlasenko150d2fa2007-07-17 20:39:27 +0000173 fi
174 done
175 # All libs were needed, can't remove any
176 $all_needed && break
Denis Vlasenkodd316dd2008-06-14 15:50:55 +0000177 # Optimization: was the last tried lib needed?
178 if $last_needed; then
179 # Was it the only one lib left? Don't test again then.
180 { echo "$LDLIBS" | grep -q ' '; } || break
181 fi
Denis Vlasenko150d2fa2007-07-17 20:39:27 +0000182done
183
Denis Vlasenko9862e6b2007-09-03 11:28:14 +0000184# Make the binary with final, minimal list of libs
Mike Frysinger49d15892007-11-18 06:42:56 +0000185echo "Final link with: ${LDLIBS:-<none>}"
Mike Frysinger3eab2b72013-09-12 00:29:40 -0400186l_list=`echo " $LDLIBS " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
Dan Fandrichebeac162010-06-18 22:36:10 -0700187test "x$l_list" != "x" && l_list="$START_GROUP $l_list $END_GROUP"
Denis Vlasenko9862e6b2007-09-03 11:28:14 +0000188# --verbose gives us gobs of info to stdout (e.g. linker script used)
189if ! test -f busybox_ldscript; then
Denis Vlasenkof1d93ec2008-02-14 12:24:14 +0000190 try $CC $CFLAGS $LDFLAGS \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000191 -o $EXE \
Bernhard Reutner-Fischera88585a2010-05-21 12:11:34 +0200192 $SORT_COMMON \
Denis Vlasenko130f5592007-11-13 17:36:12 +0000193 $SORT_SECTION \
Denis Vlasenkoa2dcb502008-04-30 00:15:56 +0000194 $GC_SECTIONS \
Dan Fandrichebeac162010-06-18 22:36:10 -0700195 $START_GROUP $O_FILES $A_FILES $END_GROUP \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000196 $l_list \
Dan Fandrichebeac162010-06-18 22:36:10 -0700197 $INFO_OPTS \
Denis Vlasenkod19b87e2007-10-09 13:08:02 +0000198 || {
199 cat $EXE.out
200 exit 1
201 }
Denis Vlasenko9862e6b2007-09-03 11:28:14 +0000202else
203 echo "Custom linker script 'busybox_ldscript' found, using it"
Denis Vlasenko76a6b232007-10-07 17:05:42 +0000204 # Add SORT_BY_ALIGNMENT to linker script (found in $EXE.out):
Denis Vlasenko9862e6b2007-09-03 11:28:14 +0000205 # .rodata : { *(.rodata SORT_BY_ALIGNMENT(.rodata.*) .gnu.linkonce.r.*) }
206 # *(.data SORT_BY_ALIGNMENT(.data.*) .gnu.linkonce.d.*)
207 # *(.bss SORT_BY_ALIGNMENT(.bss.*) .gnu.linkonce.b.*)
Denis Vlasenko76a6b232007-10-07 17:05:42 +0000208 # This will eliminate most of the padding (~3kb).
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000209 # Hmm, "ld --sort-section alignment" should do it too.
Denis Vlasenkof1d93ec2008-02-14 12:24:14 +0000210 try $CC $CFLAGS $LDFLAGS \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000211 -o $EXE \
Bernhard Reutner-Fischera88585a2010-05-21 12:11:34 +0200212 $SORT_COMMON \
Denis Vlasenko130f5592007-11-13 17:36:12 +0000213 $SORT_SECTION \
Denis Vlasenkoa2dcb502008-04-30 00:15:56 +0000214 $GC_SECTIONS \
Bernhard Reutner-Fischer50dbed92008-05-09 12:43:04 +0000215 -Wl,-T,busybox_ldscript \
Dan Fandrichebeac162010-06-18 22:36:10 -0700216 $START_GROUP $O_FILES $A_FILES $END_GROUP \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000217 $l_list \
Dan Fandrichebeac162010-06-18 22:36:10 -0700218 $INFO_OPTS \
Denis Vlasenkod19b87e2007-10-09 13:08:02 +0000219 || {
220 cat $EXE.out
221 exit 1
222 }
Denis Vlasenko9862e6b2007-09-03 11:28:14 +0000223fi
Denis Vlasenko32404742007-10-07 17:05:22 +0000224
Denis Vlasenko42e41822007-10-09 18:01:13 +0000225. ./.config
Denis Vlasenko32404742007-10-07 17:05:22 +0000226
Denis Vlasenkodef88982007-10-07 17:06:01 +0000227sharedlib_dir="0_lib"
228
229if test "$CONFIG_BUILD_LIBBUSYBOX" = y; then
230 mkdir "$sharedlib_dir" 2>/dev/null
231 test -d "$sharedlib_dir" || {
232 echo "Cannot make directory $sharedlib_dir"
233 exit 1
234 }
235 ln -s "libbusybox.so.$BB_VER" "$sharedlib_dir"/libbusybox.so 2>/dev/null
236
237 EXE="$sharedlib_dir/libbusybox.so.${BB_VER}_unstripped"
Denis Vlasenkof1d93ec2008-02-14 12:24:14 +0000238 try $CC $CFLAGS $LDFLAGS \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000239 -o $EXE \
240 -shared -fPIC \
241 -Wl,--enable-new-dtags \
242 -Wl,-z,combreloc \
243 -Wl,-soname="libbusybox.so.$BB_VER" \
Denis Vlasenko9b49a5e2007-10-11 10:05:36 +0000244 -Wl,--undefined=lbb_main \
Bernhard Reutner-Fischera88585a2010-05-21 12:11:34 +0200245 $SORT_COMMON \
Denis Vlasenko130f5592007-11-13 17:36:12 +0000246 $SORT_SECTION \
Dan Fandrichebeac162010-06-18 22:36:10 -0700247 $START_GROUP $A_FILES $END_GROUP \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000248 $l_list \
Dan Fandrichebeac162010-06-18 22:36:10 -0700249 $INFO_OPTS \
Denis Vlasenkodef88982007-10-07 17:06:01 +0000250 || {
251 echo "Linking $EXE failed"
252 cat $EXE.out
253 exit 1
254 }
Denis Vlasenko141750e2007-10-10 10:05:35 +0000255 $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/libbusybox.so.$BB_VER"
Denis Vlasenkod62fd842007-10-07 20:46:34 +0000256 chmod a+x "$sharedlib_dir/libbusybox.so.$BB_VER"
Denis Vlasenkodef88982007-10-07 17:06:01 +0000257 echo "libbusybox: $sharedlib_dir/libbusybox.so.$BB_VER"
258fi
Denis Vlasenko32404742007-10-07 17:05:22 +0000259
Denis Vlasenkodef88982007-10-07 17:06:01 +0000260if test "$CONFIG_FEATURE_SHARED_BUSYBOX" = y; then
261 EXE="$sharedlib_dir/busybox_unstripped"
Denis Vlasenkof1d93ec2008-02-14 12:24:14 +0000262 try $CC $CFLAGS $LDFLAGS \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000263 -o $EXE \
Bernhard Reutner-Fischera88585a2010-05-21 12:11:34 +0200264 $SORT_COMMON \
Denis Vlasenko130f5592007-11-13 17:36:12 +0000265 $SORT_SECTION \
Denis Vlasenkoa2dcb502008-04-30 00:15:56 +0000266 $GC_SECTIONS \
Dan Fandrichebeac162010-06-18 22:36:10 -0700267 $START_GROUP $O_FILES $END_GROUP \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000268 -L"$sharedlib_dir" -lbusybox \
Steve Iribarneed607a82011-05-09 01:42:12 +0200269 $l_list \
Dan Fandrichebeac162010-06-18 22:36:10 -0700270 $INFO_OPTS \
Denis Vlasenkodef88982007-10-07 17:06:01 +0000271 || {
272 echo "Linking $EXE failed"
273 cat $EXE.out
274 exit 1
275 }
Denis Vlasenko141750e2007-10-10 10:05:35 +0000276 $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/busybox"
Denis Vlasenkodef88982007-10-07 17:06:01 +0000277 echo "busybox linked against libbusybox: $sharedlib_dir/busybox"
278fi
Denis Vlasenkof545be02007-10-07 17:06:26 +0000279
280if test "$CONFIG_FEATURE_INDIVIDUAL" = y; then
Denis Vlasenkoe9fd69c2007-10-08 22:16:14 +0000281 echo "Linking individual applets against libbusybox (see $sharedlib_dir/*)"
Denys Vlasenko5fd3ddf2014-04-19 15:04:39 +0200282 gcc -DNAME_MAIN -E -include include/autoconf.h include/applets.h \
Denis Vlasenkof545be02007-10-07 17:06:26 +0000283 | grep -v "^#" \
284 | grep -v "^$" \
Denis Vlasenkoe9fd69c2007-10-08 22:16:14 +0000285 > applet_lst.tmp
Denis Vlasenko642a52d2007-10-07 21:00:41 +0000286 while read name main junk; do
Denis Vlasenkof545be02007-10-07 17:06:26 +0000287
288 echo "\
Denis Vlasenko15cb4a42007-10-11 10:06:26 +0000289void lbb_prepare(const char *applet, char **argv);
Denis Vlasenkod62fd842007-10-07 20:46:34 +0000290int $main(int argc, char **argv);
Denis Vlasenkof545be02007-10-07 17:06:26 +0000291
Denis Vlasenkof545be02007-10-07 17:06:26 +0000292int main(int argc, char **argv)
293{
Denis Vlasenko15cb4a42007-10-11 10:06:26 +0000294 lbb_prepare(\"$name\", argv);
Denis Vlasenkod62fd842007-10-07 20:46:34 +0000295 return $main(argc, argv);
Denis Vlasenkof545be02007-10-07 17:06:26 +0000296}
297" >"$sharedlib_dir/applet.c"
298
299 EXE="$sharedlib_dir/$name"
Denis Vlasenkof1d93ec2008-02-14 12:24:14 +0000300 try $CC $CFLAGS $LDFLAGS "$sharedlib_dir/applet.c" \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000301 -o $EXE \
Bernhard Reutner-Fischera88585a2010-05-21 12:11:34 +0200302 $SORT_COMMON \
Denis Vlasenko130f5592007-11-13 17:36:12 +0000303 $SORT_SECTION \
Denis Vlasenkoa2dcb502008-04-30 00:15:56 +0000304 $GC_SECTIONS \
Denis Vlasenko01f3b2c2007-10-09 13:49:26 +0000305 -L"$sharedlib_dir" -lbusybox \
306 -Wl,--warn-common \
Denis Vlasenkof545be02007-10-07 17:06:26 +0000307 || {
308 echo "Linking $EXE failed"
Denis Vlasenko8d755ad2007-10-09 10:15:41 +0000309 cat $EXE.out
Denis Vlasenkof545be02007-10-07 17:06:26 +0000310 exit 1
311 }
312 rm -- "$sharedlib_dir/applet.c" $EXE.out
Denis Vlasenko141750e2007-10-10 10:05:35 +0000313 $STRIP -s --remove-section=.note --remove-section=.comment $EXE
Denys Vlasenkoe3366d62014-05-03 16:35:15 +0200314 # Let user see that we do something - list the names of created binaries:
315 echo "$EXE"
Denis Vlasenkof545be02007-10-07 17:06:26 +0000316
Denis Vlasenkoe9fd69c2007-10-08 22:16:14 +0000317 done <applet_lst.tmp
Denis Vlasenkof545be02007-10-07 17:06:26 +0000318fi
Denis Vlasenkod62fd842007-10-07 20:46:34 +0000319
320# libbusybox.so is needed only for -lbusybox at link time,
321# it is not needed at runtime. Deleting to reduce confusion.
Denis Vlasenko8d755ad2007-10-09 10:15:41 +0000322rm "$sharedlib_dir"/libbusybox.so 2>/dev/null
323exit 0 # or else we may confuse make